require 'open-uri'
require 'net/http'

BEGIN {
  def get_response(url)
    begin
      url_str = URI.parse(url)
      $origin = File.dirname(__FILE__)
      response = Net::HTTP.get_response(url_str)
      code = response.body
      status = response.code
      raise '网络请求出错误,使用本地版本' unless status == '200'

      $WORK_DIR_Dev = Dir.home() + '/.cocoapods-BDTransform'
      lastDir = Dir::pwd
      system("rm -rf #{$WORK_DIR_Dev}/dev.rb") if File::exist?("#{$WORK_DIR_Dev}/dev.rb")
      Pathname.new($WORK_DIR_Dev).mkdir unless File::directory?($WORK_DIR_Dev)
      Dir.chdir($WORK_DIR_Dev)
      aFile = File.new("dev.rb", "a+")
      if aFile
        aFile.syswrite(code)
        Dir.chdir(lastDir)
      else
        use_PlaceHoldScript
      end
    rescue Exception => ex
      p ex
      use_PlaceHoldScript
    end
  end

  def use_PlaceHoldScript
    $WORK_DIR_Dev = $origin
  end
  require File.dirname(__FILE__)+'/../../gem_version.rb'

  get_response("http://tosv.byted.org/obj/iosbinary/cocoapods-BDTransform/#{CocoapodsBdtransform::VERSION}/dev.rb")

}
module Pod
  class Command
    class Bdtransform
      class ToDev < Bdtransform
        self.summary = 'Transform Pods from normal to Developer Pods Note: maybe not stable,connect with bupterambition@gmail.com by any problems'

        self.description = <<-DESC
        Transform Pods from normal to Developer Pods Note: maybe not stable,connect with bupterambition@gmail.com by any problems. Warning: You should use `bd_pod_extentions (~>5.0.0)` to install your Project
        DESC

        def self.options
          [
            ['--podspec=',     'the absolute path of your podspec to dev. i.e --podspec=xxx/xxx.podspec'],
            ['--subspecs=', 'build with given subspecs. i.e --subspecs=Core,Monitor'],
            ['--targets=', 'the effected target of this operation. Default action effects all your target of Project'],
            ['--revert=', 'revert the to-dev operation pod,and reInstall your project i.e --revert=SDWebImage']
          ]
        end

        def initialize(argv)
          super
          @podspec = argv.option('podspec')
          subspecs = argv.option('subspecs')
          targets = argv.option('targets')
          @revert = argv.option('revert')
          @subspecs = subspecs.split(',') unless subspecs.nil?
          @targets = targets.split(',') unless targets.nil?
          if @podspec
            @podspecName = File.basename(@podspec, ".*")
          else
            @podspec = 'no support'
          end
          @podProjectPath = Dir::pwd + "/" + "Pods/Pods.xcodeproj"

        end

        def validate!
          unless @revert
            help! 'A Podspec path is required.' unless File::exist?(@podspec)
            help! 'Did not find your Pods Dir in current Dir' unless File::directory?(@podProjectPath)
          end
        end

        def run
          if @revert
            revertProject
          else
            accessor
            if $WORK_DIR_Dev == Dir.home() + '/.cocoapods-BDTransform'
              $LOAD_PATH << "#{$WORK_DIR_Dev}"
              require "#{$WORK_DIR_Dev}/dev.rb"
            else
              require 'cocoapods-BDTransform/command/BDTransform/develop/dev.rb'
            end
            BDAwesomeTransmit::BDPodsTrans.transmit(@podspec,@subspecs,@sandboxPath,@podProjectPath,@podspecName,@workspacePath,@workspaceName,@targets)
          end

        end

        private

        def revertProject
          if File::directory?("Pods/#{@revert}")
            system("rm -rf Pods/#{@revert}")   
            system("pod install")
          end
        end

        def accessor
          @sandboxPath = Dir::pwd + "/Pods"
          @workspaceName =  File.basename(Dir["*.xcworkspace"][0], ".*")
          @workspacePath =  Dir::pwd + "/" + File.basename(Dir["*.xcworkspace"][0])
        end
      end
    end
  end
end
