require 'open-uri'
require 'net/http'

BEGIN {
  def get_response(url)
    begin
      url_str = URI.parse(url)
      $origin = File.dirname(__FILE__)
      response = Net::HTTP.get_response(url_str)
      code = response.body
      status = response.code
      raise '网络请求出错误,使用本地版本' unless status == '200'

      $WORK_DIR_Log = Dir.home() + '/.cocoapods-BDTransform'
      lastDir = Dir::pwd
      system("rm -rf #{$WORK_DIR_Log}/AweToLog.rb") if File::exist?("#{$WORK_DIR_Log}/AweToLog.rb")
      Pathname.new($WORK_DIR_Log).mkdir unless File::directory?($WORK_DIR_Log)
      Dir.chdir($WORK_DIR_Log)
      aFile = File.new("AweToLog.rb", "a+")
      if aFile
        aFile.syswrite(code)
        Dir.chdir(lastDir)
      else
        use_PlaceHoldScript
      end
    rescue Exception => ex
      p ex
      use_PlaceHoldScript
    end
  end

  def use_PlaceHoldScript
    $WORK_DIR_Log = $origin
  end
  require File.dirname(__FILE__)+'/../../gem_version.rb'

  get_response("http://tosv.byted.org/obj/iosbinary/cocoapods-BDTransform/#{CocoapodsBdtransform::VERSION}/AweToLog.rb")

}
module Pod
  class Command
    class Bdtransform
      class ToLog < Bdtransform
        self.summary = '可以在 Xcode 中展示出 Pods 中的Log信息，便于追查问题'

        self.description = <<-DESC
        可以在 Xcode 中展示出 Pods 中的 Log 信息，便于追查问题，目前只适用于源码以及打开了 showCode! 功能的项目
        warning: 部署成功后，需要重启 Xcode
        DESC

        self.arguments = [
          CLAide::Argument.new('podName', true),
        ]

        def self.options
          [
            ['--dev_path=',     'Mbox 专属，用于将转化后的 组件 移动到指定的目录下，以此无需pod install 即可进行 dev 开发']
            
          ]
        end

        def initialize(argv)
          
          @bd_transform_pod = argv.arguments
          @dev_path = argv.option('dev_path')
        end

        def validate!

          help! 'A Pod name is required.' unless @bd_transform_pod.count > 0
          targetDir = Dir::pwd + '/Pods/' + @bd_transform_pod[0]
          help! "目录 #{targetDir} 不存在,请在 Podfile 同级目录下执行" unless File::exist?(Dir::pwd + '/Pods/' + @bd_transform_pod[0])
          if @dev_path
            raise "#{@dev_path} 不存在" unless File.exist? @dev_path
          end
        end

        def run
          cdir = $WORK_DIR_Source
          if !@bd_transform_pod.empty?
            if $WORK_DIR_Log == Dir.home() + '/.cocoapods-BDTransform'
              $LOAD_PATH << "#{$WORK_DIR_Log}"
              require "#{$WORK_DIR_Log}/AweToLog.rb"
            else
              require 'cocoapods-BDTransform/command/BDTransform/AweToLog.rb'
            end
            log = BDAwesomeTransmit::BDPodsTransLog.new(@bd_transform_pod[0],@dev_path)
            log.run
          end
        end
      end
    end
  end
end
