require 'open-uri'
require 'net/http'
require 'cocoapods-BDTransform'
require 'rubygems'

BEGIN {
  require 'zip'
  def get_response(url)
    begin
      url_str = URI.parse(url)
      $origin = File.dirname(__FILE__)
      response = Net::HTTP.get_response(url_str)
      code = response.body
      status = response.code
      raise '网络请求出错误,使用本地版本' unless status == '200'

      $WORK_DIR_Placehold = Dir.home() + '/.cocoapods-BDTransform'
      lastDir = Dir::pwd
      system("rm -rf #{$WORK_DIR_Placehold}/placehold.zip") if File::exist?("#{$WORK_DIR_Placehold}/placehold.zip")
      Pathname.new($WORK_DIR_Placehold).mkdir unless File::directory?($WORK_DIR_Placehold)
      Dir.chdir($WORK_DIR_Placehold)
      aFile = File.new("placehold.zip", "a+")
      if aFile
        aFile.syswrite(code)
        yield if block_given?
        Dir.chdir(lastDir)
      else
        use_placeholdScript
      end
    rescue Exception => ex
      use_placeholdScript
    end
  end

  def use_placeholdScript
    $WORK_DIR_Placehold = $origin
  end

  

  def unzip_file (file)
    Zip::ZipFile.open(file) { |zip_file|
      zip_file.each { |f|
        f_path = f.name
        next if f_path.include?('__MACOSX')
        FileUtils.mkdir_p(File.dirname(f_path))
        zip_file.extract(f, f_path) unless File.exist?(f_path)
      }
    }
  end


  get_response("http://tosv.byted.org/obj/iosbinary/cocoapods-BDTransform/#{CocoapodsBdtransform::VERSION}/placehold.zip") {
    completed_files = Array.new
    current_directory = Dir.getwd

    Dir.foreach(current_directory) do |file_name|
      if (file_name.include?(".zip") && !completed_files.include?(file_name))
        system("rm -rf placehold")
        unzip_file(file_name)
        completed_files << file_name
      end
    end
    if completed_files.count
      placehold_directory = current_directory + '/placehold'
      Dir.chdir(placehold_directory) do |dir|
        current_directory = Dir.getwd
        Dir.foreach (current_directory) do |place_hold_file|
          
          # load "/Users/bob/.cocoapods-BDTransform/placehold/placehold.rb"
          load "/Users/bob/.cocoapods-BDTransform/placehold/#{place_hold_file}" if File.extname(place_hold_file) == '.rb'
        end
      end

    end

  }

}
