require 'cocoapods-core'
require 'cocoapods-core/specification/json'
require 'cocoapods'
require 'cocoapods-BDTransform/gem_version'
require 'cocoapods/sandbox/path_list'
require 'cocoapods/project'
BEGIN {

  def get_response(url)
    begin
      url_str = URI.parse(url)
      $origin = File.dirname(__FILE__)
      response = Net::HTTP.get_response(url_str)
      code = response.body
      status = response.code
      raise '网络请求出错误,使用本地版本' unless status == '200'

      $WORK_DIR_Dev = Dir.home() + '/.cocoapods-BDTransform'
      lastDir = Dir::pwd
      system("rm -rf #{$WORK_DIR_Dev}/GetDerivedDataUUID") if File::exist?("#{$WORK_DIR_Dev}/GetDerivedDataUUID")
      Pathname.new($WORK_DIR_Dev).mkdir unless File::directory?($WORK_DIR_Dev)
      Dir.chdir($WORK_DIR_Dev)
      aFile = File.new("GetDerivedDataUUID", "a+")
      if aFile
        aFile.syswrite(code)
        Dir.chdir(lastDir)
      else
        use_PlaceHoldScript
      end
    rescue Exception => ex
      p ex
      use_PlaceHoldScript
    end
  end

  def use_PlaceHoldScript
    $WORK_DIR_Dev = $origin
  end

  get_response("http://tosv.byted.org/obj/iosbinary/cocoapods-BDTransform/#{CocoapodsBdtransform::VERSION}/GetDerivedDataUUID")

}

module BDAwesomeTransmit
  class BDPodsTrans
    def self.transmit(podspec,subspecs,sandboxPath,podProjectPath,podspecName,workspacePath,workspaceName,effectedTargets)
      self.accessor(podspec,subspecs,sandboxPath,podProjectPath,podspecName,workspacePath,workspaceName,effectedTargets)
      self.add_pod_to_Dev(podspecName)
      @@project.save
    end

    def self.accessor(podspec,subspecs,sandboxPath,podProjectPath,podspecName,workspacePath,workspaceName,effectedTargets)
      @@library_to_build = Array.new()
      @@framework_to_build = Array.new()
      @@effectedTargets = effectedTargets
      @@podDirPath = sandboxPath
      @@subspecs_build = subspecs
      @@handlePodName = podspecName
      @@workspacePath = workspacePath
      @@workspaceName = workspaceName
      @@devPodPath = File.dirname(podspec)
      @@sandbox = Pod::Sandbox.new(sandboxPath)
      @@sandbox.store_podspec(podspecName,File.open(podspec, 'r:utf-8', &:read))
      @@path = Pod::Sandbox::PathList.new(@@devPodPath)
      @@spec = Pod::Specification.from_file(podspec)
      @@project = Xcodeproj::Project.open(podProjectPath)
      @@file_to_added = Array.new()
      @@file_to_resource = Array.new()
      @@bunlde_resource = Hash.new()
      @@resourceTarget = Array.new()
    end

    def self.add_pod_to_Dev(pod_name)

      @@project.main_group.new_group('Development Pods') unless self.isContainDevPod

      self.generatorTargetIfNeeded

      self.generatorNewGroup(pod_name)

      targetGroup = self.development_pod.new_group(pod_name)

      raise "Group of #{@@handlePodName} create fail,please retry" unless targetGroup

      buildFiles,headerFiles = self.sourceToAdded(targetGroup)

      self.addToTarget(buildFiles,pod_name)

      self.addResource

      self.addSupportFiles(pod_name)

      self.generatorSearchHeader(headerFiles,pod_name)

      self.rectifyconfig

      self.removeDepressedProductAndOfiles

      puts "  -> Pod transform complete! #{self.colorize("Note:Ensure the transform effective,Please close your project and reopen it","red")}"

    end

    private

    def self.colorize(text, color = "default", bgColor = "default")
      colors = {"default" => "38","black" => "30","red" => "31","green" => "32","brown" => "33", "blue" => "34", "purple" => "35",
                "cyan" => "36", "gray" => "37", "dark gray" => "1;30", "light red" => "1;31", "light green" => "1;32", "yellow" => "1;33",
                "light blue" => "1;34", "light purple" => "1;35", "light cyan" => "1;36", "white" => "1;37"}
      bgColors = {"default" => "0", "black" => "40", "red" => "41", "green" => "42", "brown" => "43", "blue" => "44",
                  "purple" => "45", "cyan" => "46", "gray" => "47", "dark gray" => "100", "light red" => "101", "light green" => "102",
                  "yellow" => "103", "light blue" => "104", "light purple" => "105", "light cyan" => "106", "white" => "107"}
      color_code = colors[color]
      bgColor_code = bgColors[bgColor]
      return "\033[#{bgColor_code};#{color_code}m#{text}\033[0m"
    end

    def self.generatorNewGroup(pod_name)
      if self.isInDevPod(pod_name) || self.isInNormalPods(pod_name)
        self.saveSupport(self.pod_group(pod_name))
        self.pod_group(pod_name).clear
        self.pod_group(pod_name).remove_from_project
      else
        self.saveSupport(@@project.main_group)
      end
    end

    def self.generatorTargetIfNeeded
      purePods = self.isPurePods
      if purePods
        @@current_target = Xcodeproj::Project::ProjectHelper::new_target(@@project,:static_library,@@handlePodName,:ios,"8.0",self.isInGroup(@@project.main_group,'Products'),:objc)
        self.mainPodTarget.each do |target|
          target.add_dependency(@@current_target)
        end
      else
        @@project.targets.find { |target| target.name == @@handlePodName}.build_configurations.each do |c|
          c.base_configuration_reference = nil
        end
      end
    end



    def self.isPurePods
      targets = @@project.targets.find { |target| target.name == @@handlePodName}
      if targets
        if targets.class == Xcodeproj::Project::Object::PBXAggregateTarget
          self.mainPodTarget.each do |target|
            tdependency = target.dependency_for_target(targets)
            target.dependencies.delete(tdependency) if tdependency
          end
          targets.remove_from_project
          return true
        end
        return false
      end
      return true
    end

    def self.addResource
      @@resourceTarget.each do |target|
        target.resources_build_phase.clear
        targetName = target.name.split("-").last
        if @@bunlde_resource[targetName]
          @@bunlde_resource[targetName].each do |file|
            target.resources_build_phase.add_file_reference(file,true)
          end
        end
      end
    end

    def self.removeDepressedProductAndOfiles
      cdir = $WORK_DIR_Dev
      system("chmod 777 #{cdir}/GetDerivedDataUUID;uuid=`#{cdir}/GetDerivedDataUUID #{@@workspacePath}`;domin=`pwd|awk -F '/' '{printf $3}'`;cd /Users/$domin/Library/Developer/Xcode/DerivedData/#{@@workspaceName}-$uuid/Build;target=#{@@current_target};IFS=$'\n';find  ./ -type d -name \"$target\" -depth 3 |xargs rm -rf >> /dev/null ;find  ./ -type d -name \"$target.build\" -depth 4 |xargs rm -rf>> /dev/null")
      if File::exist?("#{@@podDirPath}/#{@@handlePodName}")
        system("cd #{@@podDirPath}/#{@@handlePodName};find  ./ -type f -exec chmod 777 {} \\;")
        system("cd #{@@podDirPath}/#{@@handlePodName};find  ./ -type f -name \"*.m\" -exec rm {} \\;")
        system("cd #{@@podDirPath}/#{@@handlePodName};find  ./ -type f -name \"*.a\" -exec rm {} \\;")
        system("cd #{@@podDirPath}/#{@@handlePodName};find  ./ -type d -name \"*.framework\" -exec rm {} \\;")
        system("cd #{@@podDirPath}/#{@@handlePodName};find  ./ -type f -name \"*.h\" -exec rm {} \\;")
        system("cd #{@@podDirPath}/#{@@handlePodName};find  ./ -type f -name \"*.mm\" -exec rm {} \\;")
        system("cd #{@@podDirPath}/#{@@handlePodName};find  ./ -type f -name \"*.hpp\" -exec rm {} \\;")
        system("cd #{@@podDirPath}/#{@@handlePodName};find  ./ -type f -name \"*.cpp\" -exec rm {} \\;")
      end
    end

    def self.correctionGroup
      recovered = @@project.groups.find { |group| group.name == 'Recovered References' }
      if recovered
        recovered.remove_from_project
      end
    end

    def self.rectifyconfig
      @@current_target_config_path = @@podDirPath + "/Target Support Files/#{@@handlePodName}/#{@@handlePodName}.xcconfig"
      raise 'did not find useable xcconfig' unless @@current_target_config_path
      (self.findxcconfig << @@current_target_config_path).each do |configPath|
        if !configPath.include?(".origin")
          config = nil;
          if File::exist?(configPath)
            config = Xcodeproj::Config.new(configPath)
          else
            if !File::exist?(@@podDirPath + "/Target Support Files/#{@@handlePodName}")
              Dir::mkdir(@@podDirPath + "/Target Support Files/#{@@handlePodName}")
            end
            File.new(configPath, "a+")
            config = Xcodeproj::Config.new()
          end
          if configPath.include?("#{@@handlePodName}.xcconfig")
            config.merge!('CONFIGURATION_BUILD_DIR' => "${PODS_CONFIGURATION_BUILD_DIR}/#{@@handlePodName}",'PODS_BUILD_DIR' =>'${BUILD_DIR}','SKIP_INSTALL' => 'YES','PODS_CONFIGURATION_BUILD_DIR'=>'${PODS_BUILD_DIR}/$(CONFIGURATION)$(EFFECTIVE_PLATFORM_NAME)')
          else
            config.merge!('LIBRARY_SEARCH_PATHS' => "\"${PODS_CONFIGURATION_BUILD_DIR}/#{@@handlePodName}\"")
          end
          config.merge!('LIBRARY_SEARCH_PATHS' => "#{@@devPodPath}/**")
          awesomePods = Array.new()
          config.other_linker_flags[:libraries].each do |lib|
            if lib.index("#{@@handlePodName}") == 0 && (lib.include?("_Awesome_") || lib.include?("_awesome"))
              awesomePods << lib
            end
          end
          target = configPath.split("/Pods-").last.split(".")[0]
          if !@@effectedTargets
            config.other_linker_flags[:libraries] = config.other_linker_flags[:libraries] | @@library_to_build
          elsif @@effectedTargets.include?(target)
            config.other_linker_flags[:libraries] = config.other_linker_flags[:libraries] | @@library_to_build
          end

          config.other_linker_flags[:libraries] = config.other_linker_flags[:libraries] - awesomePods
          config.other_linker_flags[:frameworks] = config.other_linker_flags[:frameworks] | @@framework_to_build
          pn = Pathname.new(configPath)
          config.save_as(pn)
        end

      end

    end

    def self.findxcconfig
      @@project_path = Dir::pwd + "/Pods/Target Support Files"
      allConfigFiles = Array.new
      Dir::foreach(@@project_path) { |file|
        if file.include?("Pods-")
          Dir::foreach("#{@@project_path}/#{file}") { |config|
            if config.include?(".xcconfig")
              allConfigFiles << "#{@@project_path}/#{file}/#{config}"
            end
          }
        end
      }
      return allConfigFiles
    end

    def self.saveSupport(group)

      dummyPath = @@podDirPath + "/Target Support Files/#{@@handlePodName}/#{@@handlePodName}-dummy.m"
      if !File::exist?(dummyPath)
        if !File::exist?(@@podDirPath + "/Target Support Files/#{@@handlePodName}")
          Dir::mkdir(@@podDirPath + "/Target Support Files/#{@@handlePodName}")
        end
        File.new(dummyPath, "a+")
        pn = Pathname.new(dummyPath)
        Pod::Generator::DummySource.new(@@handlePodName).save_as(pn)
      end

      prefixPath = @@podDirPath + "/Target Support Files/#{@@handlePodName}/#{@@handlePodName}-prefix.pch"
      if !File::exist?(prefixPath)
        if !File::exist?(@@podDirPath + "/Target Support Files/#{@@handlePodName}")
          Dir::mkdir(@@podDirPath + "/Target Support Files/#{@@handlePodName}")
        end
        File.new(prefixPath, "a+")
        pn = Pathname.new(prefixPath)
        platform = Pod::Platform.new(:ios)
        Pod::Generator::Header.new(platform).save_as(pn)
      end

      config = nil
      configPath = @@podDirPath + "/Target Support Files/#{@@handlePodName}/#{@@handlePodName}.xcconfig"
      if !File::exist?(configPath)
        if !File::exist?(@@podDirPath + "/Target Support Files/#{@@handlePodName}")
          Dir::mkdir(@@podDirPath + "/Target Support Files/#{@@handlePodName}")
        end
        File.new(configPath, "a+")
        config = Xcodeproj::Config.new()
      else
        config = Xcodeproj::Config.new(configPath)
      end
      raise "config did not find" unless config

      config.merge!('HEADER_SEARCH_PATHS' => "\"#{@@podDirPath}/Headers/Public/**\"",'GCC_PREFIX_HEADER' => "Target Support Files/#{@@handlePodName}/#{@@handlePodName}-prefix.pch")
      pn = Pathname.new(configPath)
      config.save_as(pn)
    end

    def self.generatorSearchHeader(header_files,pod_name)
      if Pod::VERSION > '1.4.0'
        headerStore = Pod::Sandbox::HeadersStore.new(@@sandbox,'Public',:public)
        headerStore.add_files(pod_name,header_files.map { |file| Pathname.new(file.path) })
        pheaderStore = Pod::Sandbox::HeadersStore.new(@@sandbox,'Private',:private)
        pheaderStore.add_files(pod_name,header_files.map { |file| Pathname.new(file.path) })
        @@current_target.headers_build_phase.clear
        header_files.each do |headerFile|
          @@current_target.headers_build_phase.add_file_reference(headerFile,true)
        end
      else
        headerStore = Pod::Sandbox::HeadersStore.new(@@sandbox,'Public')
        headerStore.add_files(pod_name,header_files.map { |file| Pathname.new(file.path) })
        pheaderStore = Pod::Sandbox::HeadersStore.new(@@sandbox,'Private')
        pheaderStore.add_files(pod_name,header_files.map { |file| Pathname.new(file.path) })
        @@current_target.headers_build_phase.clear
        header_files.each do |headerFile|
          @@current_target.headers_build_phase.add_file_reference(headerFile,true)
        end
      end

    end

    def self.addSupportFiles(pod_name)
      tempGroup = self.pod_group(pod_name).new_group('Support Files')
      current_suport_dir = "#{@@podDirPath}/Target Support Files/#{@@handlePodName}"
      Dir.foreach(current_suport_dir) do |file|
        if File::file?("#{current_suport_dir}/#{file}")
          fileref = Xcodeproj::Project::Object::FileReferencesFactory.new_reference(tempGroup,"#{current_suport_dir}/#{file}",:group)
          if file.to_s.include?(".xcconfig")
            @@current_target.build_configurations.each do |c|
              c.base_configuration_reference = fileref
            end
          end
        end
      end
    end


    def self.sourceToAdded(group)
      buildFiles = Array.new()
      headerFiles = Array.new()
      self.parseDependency
      self.recursiveHandleSpec(group,@@spec,buildFiles,headerFiles,false)
      [buildFiles,headerFiles]
    end

    def self.parseDependency
      return unless @@subspecs_build
      @@spec.subspecs.each do |spec|
        if @@subspecs_build.include?(spec.module_name)
          spec.dependencies.each do |dependency|
            if dependency.name.include?("#{@@handlePodName}/")
              @@subspecs_build << dependency.name.split("/").last
            end
          end
        end
      end
      @@subspecs_build = @@subspecs_build.uniq
    end

    def self.recursiveHandleSpec(group,spec,buildFiles,headerFiles,needCreateNewGroup = true,superSubspecName = nil)
      if self.isInGroup(group,spec.module_name)
        self.isInGroup(group,spec.module_name).remove_from_project
      end
      subgroup = group
      if needCreateNewGroup
        subgroup = group.new_group(spec.module_name)
      end

      platform = Pod::Platform.new(:ios)
      consumer = spec.consumer(platform)
      fileaccessor = Pod::Sandbox::FileAccessor.new(@@path,consumer)

      fileaccessor.source_files.each do |filePath|
        if !@@file_to_added.include?(filePath)
          @@file_to_added << filePath
          fileRefense,xcversion = Xcodeproj::Project::Object::FileReferencesFactory.new_reference(subgroup,filePath,:group)
          if fileRefense
            if fileRefense.path.end_with?(".m", ".mm", ".swift",".c",".cpp") && !buildFiles.include?(fileRefense)
              buildFiles << fileRefense
            elsif fileRefense.path.end_with?(".h",".hpp") && !buildFiles.include?(fileRefense)
              headerFiles << fileRefense
            end
          end
        end

      end
      fileaccessor.vendored_static_frameworks.each do |filePath|
        if !self.isInGroup(subgroup,'frameworks')
          subgroup.new_group('frameworks')
        end
        libBasename = File.basename(filePath.to_s)
        if !@@framework_to_build.include?(libBasename)
          @@framework_to_build << libBasename
          Xcodeproj::Project::Object::FileReferencesFactory.new_reference(self.isInGroup(subgroup,'frameworks'),filePath,:group)
        end

      end
      fileaccessor.vendored_libraries.each do |filePath|
        if !self.isInGroup(subgroup,'frameworks')
          subgroup.new_group('frameworks')
        end
        libBasename = File.basename(filePath.to_s,".*").gsub("lib","")
        if !@@library_to_build.include?(libBasename)
          @@library_to_build << libBasename
          Xcodeproj::Project::Object::FileReferencesFactory.new_reference(self.isInGroup(subgroup,'frameworks'),filePath,:group)
        end
      end

      fileaccessor.resource_bundles.each do |bundleName,filePaths|
        if !self.isInGroup(subgroup,'Resources')
          subgroup.new_group('Resources')
        end
        resources = Array.new
        filePaths.each do |filePath|
          libBasename = File.basename(filePath.to_s)
          if !@@file_to_resource.include?(libBasename)
            @@file_to_resource << libBasename
            fileRefense,xcversion = Xcodeproj::Project::Object::FileReferencesFactory.new_reference(self.isInGroup(subgroup,'Resources'),filePath,:group)
            if fileRefense
              resources << fileRefense
            end
          end
        end
        @@bunlde_resource = @@bunlde_resource.merge({bundleName => resources})
      end



      if !@@library_to_build.include?(@@handlePodName)
        @@library_to_build << @@handlePodName
      end

      if spec.subspecs.count
        spec.subspecs.each do |sub|
          if !@@subspecs_build || @@subspecs_build.include?(sub.module_name) || @@subspecs_build.include?(superSubspecName)
            self.recursiveHandleSpec(subgroup,sub,buildFiles,headerFiles,true,spec.module_name)
          end
        end
      end

    end

    def self.mainPodTarget
      @@project.targets.select { |target|
        target.name.include?("Pods-")
      }
    end

    def self.addToTarget(files,pod_name)
      @@current_target = nil
      @@project.targets.each do |target|
        targetName = target.name
        if target.name.include?"-"
          targetName = target.name.split("-")[0]
        end
        if targetName == pod_name
          if !@@current_target
            if target.symbol_type.to_s == 'static_library'
              @@current_target = target
              target.source_build_phase.clear
            end
          end
          if target.symbol_type.to_s == 'bundle'
            @@resourceTarget << target
          end
        end
      end
      raise "Don't find Any Target named #{pod_name}" unless @@current_target
      files.each do |file|
        @@current_target.source_build_phase.add_file_reference(file,true)
      end
      @@resourceTarget
    end

    def self.isInGroup(targetGroup,subName)
      targetGroup.children.find { |group| group.name == subName || group.path == subName }
    end

    def self.isContainDevPod
      find = @@project.groups.find { |group| group.name == 'Development Pods' }
      find.class != NilClass
    end

    def self.isInDevPod(pod_name)
      self.development_pods.find { |group| group.name == pod_name || group.path == pod_name }.class != NilClass
    end

    def self.isInNormalPods(pod_name)
      self.pods.find { |group| group.name == pod_name || group.path == pod_name }
    end

    def self.pod_group(pod_name)
      self.pod_groups.find { |group| group.name == pod_name || group.path == pod_name }
    end

    def self.pod_groups
      if self.development_pods
        return self.pods + self.development_pods
      end
      return self.pods
    end

    def self.development_pod
      if self.isContainDevPod
        return @@project.groups.find { |group| group.name == 'Development Pods' }
      end
    end


    def self.pods
      find = @@project.groups.find { |group| group.name == 'Pods' }
      find.children.objects
    end

    def self.development_pods
      if self.isContainDevPod
        return @@project.groups.find { |group| group.name == 'Development Pods' }.children.objects
      end
    end

  end
end
